/**************************************************************

File Name:		FIR_mccoeff.asm
		
Date Modified:	05/22/00		GJO
				05/25/00		GJO	Code verified on rev 0.1 Silicon
				09/19/04		JDT Ported to VDSP++ 3.5. replace .SEGMENT syntax

Description:	ADSP-21364 multichannel SIMD program to call FIR.asm

**************************************************************/
#include "def21364.h"
#define SAMPLES 512
#define TAPS 	64

.EXTERN fir, fir_init;

.SECTION/PM seg_pmda;
.VAR    coefs[2*TAPS] = "mult_coeffs.dat";   /* FIR coefficient stored in file    */
.VAR    outbuf[2*SAMPLES];


.SECTION/DM seg_dmda;
.VAR    dline[2*TAPS];                    


.SECTION/DM seg_dmda;
.VAR    inbuf[2*SAMPLES]="indata1.dat";  		/* multichannel input data array */


.SECTION/PM    seg_rth;
Reserved_1:		rti; nop; nop; nop;
Chip_Reset:		idle; jump begin; nop; nop;
	


.SECTION/PM seg_pmco;
begin:  l1=0;				/* initialize for modulo addressing */
        l2=l1;
        l0=2*TAPS;			/* initialize delay line for circular buffer */
        l8=l0;
        m0=2;				/* initialize modifiers */
        m8=m0;
		m1=1;
        r1=TAPS-3;			/* setup loop count registers */
		r2=SAMPLES;			
		r5=2*TAPS;
        call fir_init (db); /* set up the FIR filter DAGs and zero delay line */		
        b0=dline;			/* pointer to delay line */
		b8=coefs;			/* pointer to coeficient array */ 
filt:	call fir (db);		/* call to fir filter routine */
		b1=inbuf;			/* pointer to input array */
        b9=outbuf;			/* pointer to output array */
done:   jump filt;
		nop;
		nop;


